
% clear all
% folder='C:\17 Jul 2015\CECR2';
% save_file='CECR2.xlsx';
% recipient = 'clarenceyapp@ndm.ox.ac.uk';
% total_wells=3;
% current_well =1;
% well_name='11';
% bromodomain = 'CECR2';
% bleach_diam=60; %REMEMBER TO UNCOMMENT ROI_DIAM change!!!! change to 25 for previous settings


subfolder=strcat(folder,'\',well_name)
A = dir(subfolder);
num_subfolders = size(find(vertcat(A.isdir)),1);



%excel initialisation

xl = actxserver('Excel.Application'); 

listing = dir(strcat(folder));
file_found=0;
for j = 1:size(listing,1)
s = listing(j).name;
if strfind(s,save_file)>0
    file_found=1;
Workbook = invoke(xl.Workbooks,'Open',strcat(folder, '\',save_file) );  

end

end

if file_found==0
     xl.Workbooks.Add(1); 
end


  set(xl,'Visible',1);


try
    sheet = get(xl.Worksheets,'Item', well_name);
    invoke(sheet, 'Activate');
catch
    % If the Excel Sheet ExperimentSheet is not found, Add an 
    % Excel Sheet, and rename the new sheet
    % to ExperimentSheet
    ExcelWorkbook = xl.Worksheets.Add;
    set(ExcelWorkbook, 'Name',  well_name);
    
end 

xls = xl.ActiveSheet;

sheet = xl.Sheets;

currentSheet = sheet.Item(well_name);
range = currentSheet.get('Range', 'A1');
range.Value = ['Verdict' ];
range = currentSheet.get('Range', 'B1');
range.Value = ['Cell number' ];
range = currentSheet.get('Range', 'C1');
range.Value = ['Halftime' ];
range = currentSheet.get('Range', 'D1');
range.Value = ['r square value' ];
range = currentSheet.get('Range', 'E1');
range.Value = ['plateau' ];
range = currentSheet.get('Range', 'F1');
range.Value = ['recovery plot' ];
range = currentSheet.get('Range', 'H1');
range.Value = ['cell image' ];
range = currentSheet.get('Range', 'J1');
range.Value = ['bleached image'];
range = currentSheet.get('Range', 'L1');
range.Value = ['mask'];

%%%%% count subfolders within each well
d = dir(subfolder);
isub = [d(:).isdir]; 
nameFolds = {d(isub).name};
nameFolds(ismember(nameFolds,{'.','..'})) = [];
%%%%%%%%%%%%%%%

%%%%%%% finding total number of lsm files in advance
alllsm=0;
for subfolder_count= 1:size(nameFolds,2)
listing = dir(strcat(subfolder,'\',char(nameFolds(subfolder_count))));
for j = 1:size(listing,1)
s = listing(j).name;
if strfind(s,'CELL ') + strfind(s,'lsm')>1
    alllsm=alllsm+1;
end
end
end
%%%%%%



gcelliter=0;


for subfolder_count= 1:size(nameFolds,2)
cell_list=0;
Num=0;
listing = dir(strcat(subfolder,'\',char(nameFolds(subfolder_count))));
for j = 1:size(listing,1)
s = listing(j).name;
if strfind(s,'CELL ') + strfind(s,'lsm')>1
    Num=Num+1;
    cell_list(Num)=sscanf(s, '%*s %d %d %*s', [1, inf]) ;
end
end


if Num<1
    break
end


cell_list=sort(cell_list);


average_halftime=[];
celliter=0;

for celliter= 1:Num
gcelliter=gcelliter+1;
filename= [folder,'\',well_name,'\',char(nameFolds(subfolder_count)),'\','Cell ',int2str(cell_list(celliter)),'.lsm'];
cell=tiffread32(filename);

ROI = bfopen(filename);
omeMeta = ROI{1, 4};
% ROI_X= round(eval(omeMeta.getEllipseX(0,0))); %use only if ROI details
% are stored in LSM file!!
% ROI_Y=round(eval(omeMeta.getEllipseY(0,0)));
% ROI_Diam_X=round(eval(omeMeta.getEllipseRadiusX(0,0)));
% ROI_Diam_Y=round(eval(omeMeta.getEllipseRadiusY(0,0)));


ROI_X= cell(1,1).height/2;
ROI_Y= cell(1,1).width/2;
% ROI_Diam_X=sqrt(2*(double(bleach_diam)^2));
% ROI_Diam_Y=sqrt(2*(double(bleach_diam)^2));
ROI_Diam_X=25;
ROI_Diam_Y=25;



mask=im2bw(cell(1).data,0.2);
mask=imclearborder(mask);
mask=bwareaopen(mask, 10000);
mask=imfill(mask,'holes');
se = strel('disk',10);
mask = imclose(mask,se);

[labeled,numObjects] = bwlabel(mask,8);
props = regionprops(labeled,'all');

if sum(sum(mask))==0
  
f1=figure;imshow(cell(1).data );
f2=figure;imshow(cell(1).data );
f3=figure;imshow(cell(6).data);
f4=figure;imshow(mask);

print(f1, '-dbitmap'); xls.Range(strcat('F',int2str(2+4*(gcelliter-1)))).PasteSpecial;
xls.Shapes.Item(1+4*(gcelliter-1)).Height  = 50;
print(f2, '-dbitmap'); xls.Range(strcat('H',int2str(2+4*(gcelliter-1)))).PasteSpecial;
xls.Shapes.Item(1+4*(gcelliter-1)+1).Height  = 50;
print(f3, '-dbitmap'); xls.Range(strcat('J',int2str(2+4*(gcelliter-1)))).PasteSpecial;
xls.Shapes.Item(1+4*(gcelliter-1)+2).Height  = 50;
print(f4, '-dbitmap'); xls.Range(strcat('L',int2str(2+4*(gcelliter-1)))).PasteSpecial;
xls.Shapes.Item(1+4*(gcelliter-1)+3).Height  = 50;
close all



range = currentSheet.get('Range', strcat('A',int2str(2+4*(gcelliter-1)),':C',int2str(2+4*(gcelliter-1))));
    range.Value = [0 cell_list(celliter) 0 ];
range = currentSheet.get('Range', strcat('D',int2str(2+4*(gcelliter-1)),':D',int2str(2+4*(gcelliter-1))));

    range.Value = ['Cell too dark!'];

    continue

end

%%%
if numObjects>1
    for ncells = 1:numObjects
        if abs(props(ncells).Centroid(1) -ROI_X) <50 && abs(props(ncells).Centroid(2) -ROI_Y) <50 
            break
        end
    end


mask = false(size(cell(1).data));
mask(props(ncells).PixelIdxList) = true;
[labeled,numObjects] = bwlabel(mask,8);
props = regionprops(labeled,'all');
end


mask_background=~im2bw((cell(1).data ),0.07);
mask_background=bwareaopen(mask_background, 10000);


% ROI_bX= 475;%cell(1,1).height/2;
% ROI_bY=475;% cell(1,1).width/2;
% [x y] = meshgrid(1:cell(1,1).height,1:cell(1,1).width);
% mask_background=((x-ROI_bX)/ROI_Diam_X).^2+((y-ROI_bY)/ROI_Diam_Y).^2<=1;

[labeled_background] = bwlabel(mask_background,8);
props_background = regionprops(labeled_background,'all');



first_average_intensity=0;
first_background_intensity=0;
first_ROI=0;
% try
for i = 1:  5
first_average_intensity= first_average_intensity+ sum(sum((cell(i).data  .* uint8(mask))))/props.Area;
first_background_intensity = first_background_intensity+sum(sum((cell(i).data  .* uint8(mask_background))))/sum(sum(mask_background));




[x y] = meshgrid(1:cell(1,1).height,1:cell(1,1).width);
mask_ROI=((x-ROI_X)/ROI_Diam_X).^2+((y-ROI_Y)/ROI_Diam_Y).^2<=1;
first_ROI=first_ROI+  sum(sum((cell(i).data  .* uint8(mask_ROI))))/pi/ROI_Diam_X/ROI_Diam_Y;

end

first_average_intensity= first_average_intensity/5;
first_background_intensity= first_background_intensity/5;
first_ROI= first_ROI/5;


normalised_ROI=zeros(1,cell(1).lsm.('DimensionTime')-5);
cell_body=zeros(1,cell(1).lsm.('DimensionTime')-5);
background=zeros(1,cell(1).lsm.('DimensionTime')-5);
ROI=zeros(1,cell(1).lsm.('DimensionTime')-5);

time=zeros(1,cell(1).lsm.('DimensionTime')-5);

if strcmp(bromodomain,'BRD4') ==1
totaltimespan=cell(1).lsm.('TimeOffset') -1.22;  %%use 2.4 for linestep 1, bidirectional; use 1.2 for linestep 2, bidirectional 0.5 sec time delay; use 2 for 500ms intervals, 0.62 for no intervals but linestep 4, use 1.22 for no intervals linestep 2; use 8 for linestep 2, 2 sec inteervals
elseif strcmp(bromodomain,'CECR2')==1
totaltimespan=cell(1).lsm.('TimeOffset') -8;  %%use 2.4 for linestep 1, bidirectional; use 1.2 for linestep 2, bidirectional 0.5 sec time delay; use 2 for 500ms intervals, 0.62 for no intervals but linestep 4, use 1.22 for no intervals linestep 2; use 8 for linestep 2, 2 sec inteervals
elseif strcmp(bromodomain,'BRPF')==1
totaltimespan=cell(1).lsm.('TimeOffset') -1.4;  %%use 2.4 for linestep 1, bidirectional; use 1.2 for linestep 2, bidirectional 0.5 sec time delay; use 2 for 500ms intervals, 0.62 for no intervals but linestep 4, use 1.22 for no intervals linestep 2; use 8 for linestep 2, 2 sec inteervals
else
   totaltimespan=cell(1).lsm.('TimeOffset') -1.22; 
    end
    %BRD4 no intervals use 1.22
%CECR2 2 sec intervals use 8
%BRPF no intervals use 1.22


for i = 6: cell(1).lsm.('DimensionTime')
average_intensity= sum(sum((cell(i).data  .* uint8(mask))))/props.Area;
average_background = sum(sum((cell(i).data  .* uint8(mask_background))))/sum(sum(mask_background));
average_ROI=  sum(sum((cell(i).data  .* uint8(mask_ROI))))/pi/ROI_Diam_X/ROI_Diam_Y;
cell_body(i-5)=average_intensity;
background(i-5)=average_background;
ROI(i-5)=average_ROI;

normalised_ROI(i-5)=(first_average_intensity-first_background_intensity)*(average_ROI - average_background)/(average_intensity-average_background)/(first_ROI-first_background_intensity);


time(i-5)=totaltimespan(i);
end

if normalised_ROI(1)<0
    normalised_ROI(:)=normalised_ROI(:)+abs(normalised_ROI(1));
end



try

fit_count=1;
sse =1;
rsquare_value =0;
infinite=1000;
start=1000;
while fit_count < 4 && (sse>0.05 ||  abs(infinite-1)> 0.3 || rsquare_value < 0.96 ||abs(start-normalised_ROI(1))>0.05)
    

    
ft=fittype ('yo+a*(1-exp(-x*b))+c*(1-exp(-x*d))');

if strcmp(bromodomain,'BRD4') 
    if fit_count==1
           [f,gof,fitoptions]= fit( transpose(time), transpose(normalised_ROI), ft,'Maxiter',1000); %use this for BRD4 and TIF and CECR2
    elseif fit_count==2
           [f,gof,fitoptions]= fit( transpose(time), transpose(normalised_ROI), ft,'Maxiter',1000,'Startpoint',[0 0 10 10 0] ); %use this for BRPF
    else
           [f,gof,fitoptions]= fit( transpose(time), transpose(normalised_ROI), ft,'Maxiter',1000,'Startpoint',[0 0 10 10 0] ); %use this for BRPF
    end

elseif strcmp(bromodomain,'FALZ') 
    if fit_count==1
           [f,gof,fitoptions]= fit( transpose(time), transpose(normalised_ROI), ft,'Maxiter',1000); %use this for BRD4 and TIF and CECR2
    elseif fit_count==2
           [f,gof,fitoptions]= fit( transpose(time), transpose(normalised_ROI), ft,'Maxiter',1000,'Startpoint',[0 0 0 0 0] ); %use this for BRPF
    else
           [f,gof,fitoptions]= fit( transpose(time), transpose(normalised_ROI), ft,'Maxiter',1000,'Startpoint',[0 2 0 0 0] ); %use this for BRPF
    end    
    

elseif strcmp(bromodomain,'BRPF') ==1
    if fit_count==1
           [f,gof,fitoptions]= fit( transpose(time), transpose(normalised_ROI), ft,'Maxiter',1000,'Startpoint',[-100 0.2 100 0.2 -0.2]); %use this for BRPF
    elseif fit_count==2
           [f,gof,fitoptions]= fit( transpose(time), transpose(normalised_ROI), ft,'Maxiter',1000,'Startpoint',[100 0.2 -100 0.2 -0.2]); %use this for BRPF
    else
           [f,gof,fitoptions]= fit( transpose(time), transpose(normalised_ROI), ft,'Maxiter',1000,'Startpoint',[0.72 0.7 0.4 0.07 -0.1]); %use this for BRPF
    end

elseif strcmp(bromodomain,'CECR2')==1
    if fit_count==1
           [f,gof,fitoptions]= fit( transpose(time), transpose(normalised_ROI), ft,'Maxiter',1000); %use this for BRPF
    elseif fit_count==2
           [f,gof,fitoptions]= fit( transpose(time), transpose(normalised_ROI), ft,'Maxiter',1000,'Startpoint',[10 0 -10 0 0] ); %use this for BRPF
    else
           [f,gof,fitoptions]= fit( transpose(time), transpose(normalised_ROI), ft,'Maxiter',1000,'Startpoint',[-5 0.1 5 0.1 0.1] ); %use this for BRPF
    end

end

sse=gof.sse;
rsquare_value=gof.rsquare;
coeff = coeffvalues(f);
infinite= coeff(5)+coeff(1)+ coeff(3);
start=coeff(5);
fit_count=fit_count+1
end


plot( f, time, normalised_ROI )
f1=figure;plot( f, time, normalised_ROI );

a=coeff(1);
b=coeff(2);
c=coeff(3);
d=coeff(4);
yo=coeff(5);

syms x;

maximum = yo+a*(1-exp(-0*b))+c*(1-exp(-0*d));
minimum = yo+a*(1-exp(-max(time)*b))+c*(1-exp(-max(time)*d));

infinite = yo+a+c;

halflife=(infinite+maximum)/2;

halftime(celliter)=fzero(strcat (num2str(yo-halflife),'+',num2str(a),'*(1-exp(-x*',num2str(b),'))+',num2str(c),'*(1-exp(-x*',num2str(d),'))'),15);



% x = solve(strcat('a*exp(-x*b)+x*c*exp(-x*d)+yo=',num2str(halflife)))
% x = solve(strcat(num2str(a),'*(1-exp(-x*',num2str(b),'))+',num2str(c),'(1-exp(-x*',num2str(d),'))+',num2str(yo),'=',num2str(halflife)))
% x = vpa(x)

% halftime(celliter)=double(x);


f2=figure;imshow(cell(1).data );
f3=figure;imshow(cell(6).data);
f4=figure;imshow(mask);


% celliter=celliter+1; %upon successful analysis of a cell

print(f1, '-dbitmap'); xls.Range(strcat('F',int2str(2+4*(gcelliter-1)))).PasteSpecial;
xls.Shapes.Item(1+4*(gcelliter-1)).Height  = 50;
print(f2, '-dbitmap'); xls.Range(strcat('H',int2str(2+4*(gcelliter-1)))).PasteSpecial;
xls.Shapes.Item(1+4*(gcelliter-1)+1).Height  = 50;
print(f3, '-dbitmap'); xls.Range(strcat('J',int2str(2+4*(gcelliter-1)))).PasteSpecial;
xls.Shapes.Item(1+4*(gcelliter-1)+2).Height  = 50;
print(f4, '-dbitmap'); xls.Range(strcat('L',int2str(2+4*(gcelliter-1)))).PasteSpecial;
xls.Shapes.Item(1+4*(gcelliter-1)+3).Height  = 50;
close all

range = currentSheet.get('Range', strcat('A',int2str(2+4*(gcelliter-1)),':E',int2str(2+4*(gcelliter-1))));

if fit_count==6 || infinite > 1.1 || rsquare_value<0.97 || halftime(celliter) <0 
    range.Value = [0 cell_list(celliter) halftime(celliter) rsquare_value infinite ];
else
    range.Value = [1 cell_list(celliter) halftime(celliter) rsquare_value infinite ];
        average_halftime(gcelliter)=halftime(celliter);
end


%standard deviation pre-calculation
range = currentSheet.get('Range', strcat('N',int2str(2+4*(gcelliter-1)),':N',int2str(2+4*(gcelliter-1))));
 range.Value = [strcat('=A', int2str(2+4*(gcelliter-1)),'*(C',int2str(2+4*(gcelliter-1)),'-$C$', int2str(7+4*(alllsm-1)),')^2')];


catch


    
f1=figure;plot(time, normalised_ROI );
f2=figure;imshow(cell(1).data );
f3=figure;imshow(cell(6).data);
f4=figure;imshow(mask);

print(f1, '-dbitmap'); xls.Range(strcat('F',int2str(2+4*(gcelliter-1)))).PasteSpecial;
xls.Shapes.Item(1+4*(gcelliter-1)).Height  = 50;
print(f2, '-dbitmap'); xls.Range(strcat('H',int2str(2+4*(gcelliter-1)))).PasteSpecial;
xls.Shapes.Item(1+4*(gcelliter-1)+1).Height  = 50;
print(f3, '-dbitmap'); xls.Range(strcat('J',int2str(2+4*(gcelliter-1)))).PasteSpecial;
xls.Shapes.Item(1+4*(gcelliter-1)+2).Height  = 50;
print(f4, '-dbitmap'); xls.Range(strcat('L',int2str(2+4*(gcelliter-1)))).PasteSpecial;
xls.Shapes.Item(1+4*(gcelliter-1)+3).Height  = 50;
    close all
    
range = currentSheet.get('Range', strcat('A',int2str(2+4*(gcelliter-1)),':C',int2str(2+4*(gcelliter-1))));
    range.Value = [0 cell_list(celliter) 0 ];
range = currentSheet.get('Range', strcat('D',int2str(2+4*(gcelliter-1)),':D',int2str(2+4*(gcelliter-1))));

    range.Value = ['Could not fit curve!'];


    continue 
end

end

end

if size(average_halftime>0)
    range = currentSheet.get('Range', strcat('C',int2str(7+4*(gcelliter-1)),':C',int2str(7+4*(gcelliter-1))));
    range.Value = [strcat('=SUMPRODUCT(A2:A',int2str(2+4*(gcelliter-1)),'*C2:C',int2str(2+4*(gcelliter-1)), ')/SUM(A2:A',int2str(2+4*(gcelliter-1)),')')];
    range = currentSheet.get('Range', strcat('C',int2str(8+4*(gcelliter-1)),':C',int2str(8+4*(gcelliter-1))));
    range.Formula = [strcat('=SQRT(SUM(N2:N',int2str(2+4*(gcelliter-1)),')/SUM(A2:A',int2str(2+4*(gcelliter-1)),'))')];
end


if file_found==0
    xls.SaveAs(strcat(folder, '\',save_file));
else
invoke(Workbook,'Save');
end

invoke(xl,'Quit');
delete(xl);



% EMAIL CODE
if current_well == total_wells
mail = 'tdiconfocal@gmail.com'; %Your GMail email address
password = 'imagesarefun';  %Your GMail password
setpref('Internet','SMTP_Server','smtp.gmail.com');



setpref('Internet','E_mail',mail);
setpref('Internet','SMTP_Username',mail);
setpref('Internet','SMTP_Password',password);
props = java.lang.System.getProperties;
props.setProperty('mail.smtp.auth','true');
props.setProperty('mail.smtp.socketFactory.class', 'javax.net.ssl.SSLSocketFactory');
props.setProperty('mail.smtp.socketFactory.port','465');
% Send the email.  Note that the first input is the address you are sending the email to



subj = 'Automated FRAP has completed a process';
msg = ...
  'This is an automated email sent from Automated FRAP. Results are attached';
attFile = strcat(folder,'\',save_file);
sendmail(recipient,subj,msg,attFile);

end

