close all

i=imread('tilescan image.tif');
thresh=0.15;
gray=i(:,:,1);
gray=imresize(gray,0.5);
gray=imresize(gray,2);
BW2=im2bw(gray,thresh);

BW2 = bwareaopen(BW2,150);

BW2= imclearborder(BW2,8);
BW2=imfill(BW2,'holes');
[labeled,numObjects] = bwlabel(BW2,8);
cells = regionprops(labeled,'all');
% imshow(labeled)

cellid=0;
success_index=1;
coordinate_list = [ ];
% 




a = readfis('fuzzy_frap');

for index =1:numObjects
    
    black=zeros(size(BW2));
    black(cells(index).PixelIdxList) = 255;
    single_cell = (uint8(black)/255).*gray;
    average_intensity = sum(sum(single_cell))/cells(index).Area;
    
    %identify intensity peaks for each cell
    peaks=sum(sum(single_cell>200))/cells(index).Area*100;
    
    %identify intensity troughs for each cell
    
    single_cell=imcrop(single_cell,cells(index).BoundingBox );
    
%     nucleolus= 1; % sum(sum(bwareaopen(single_cell<20 & single_cell>1,2))) /cells(index).Area*100;
        se = strel('disk',3);
nucleolus=sum(sum(imclearborder(imerode(im2bw(single_cell,thresh),se)-im2bw(single_cell,thresh*2))));

   
    
    %identify average intensity of cytoplasm
    cyto=sum(sum(single_cell>30))/cells(index).Area*100;
    

    
    %identify perimeter/area for each cell
    peri_area = (cells(index).Perimeter)^2/4/pi/cells(index).Area;
    
    if peaks<3 && peri_area <2 %&& nucleolus >0 %&& cyto/nucleolus >10
    low_inputs(1)=cells(index).Area;
    low_inputs(2)= average_intensity;
    low_inputs(3)=cells(index).Eccentricity;
    low_inputs(4) = peri_area;

    output = evalfis(low_inputs, a);
    if output>0.6
            if nucleolus >5
             output=output+0.3;
        end
        coordinate_list(success_index,1)=cells(index).Centroid(1,1);
        coordinate_list(success_index,2)=cells(index).Centroid(1,2);
        coordinate_list(success_index,3)=cells(index).MajorAxisLength/cells(index).MinorAxisLength;
        coordinate_list(success_index,4)=cells(index).Orientation;
        coordinate_list(success_index,5)=output;
        coordinate_list(success_index,6)=   cells(index).Area;
        coordinate_list(success_index,7)= average_intensity;
        coordinate_list(success_index,8)=cells(index).Eccentricity;
        coordinate_list(success_index,9)=peaks;
        coordinate_list(success_index,10)=peri_area;
        coordinate_list(success_index,11)=nucleolus;
        coordinate_list(success_index,12)=cyto;
        success_index=success_index+1;
    end
    end
    
end


% while (cellid<200) && (index<numObjects)
%     black=zeros(size(BW2));
%     black(cells(index).PixelIdxList) = 255;
%     single_cell = (uint8(black)/255).*gray;
%     average_intensity = sum(sum(single_cell))/cells(index).Area;
%     
% 
% profilex=imcrop(i,[cells(index).BoundingBox(1) round(cells(index).BoundingBox(2)+cells(index).BoundingBox(3)/2) round(cells(index).BoundingBox(3)/2) 0]);
% profile_x=1:1:round(cells(index).BoundingBox(3)/2)+1;
% fx=polyfit(profile_x,double(profilex(:,:,1)),1);
% 
% % profiley=imcrop(i,[round(cells(index).BoundingBox(1)+cells(index).BoundingBox(4)/2)  cells(index).BoundingBox(2) round(cells(index).BoundingBox(4)/2) 0]);
% % profile_y=1:1:round(cells(index).BoundingBox(4)/2)+1;
% % fy=polyfit(profile_y,double(profiley(:,:,1)),1);
% 
%     if (average_intensity <140) && (average_intensity >90) &&(cells(index).Area<450) && max(max(single_cell)) <250 && cells(index).Eccentricity>0.6 && fx(1) <10
%         cellid=cellid+1;
%         coordinate_list(cellid,1)=cells(index).Centroid(1,1);
%         coordinate_list(cellid,2)=cells(index).Centroid(1,2);
%         coordinate_list(cellid,3)=cells(index).MajorAxisLength/cells(index).MinorAxisLength;
%         coordinate_list(cellid,4)=cells(index).Orientation;
%         
% 
%         
%     end
%     index=index+1;
%     
% end



if size(coordinate_list)==0
        coordinate_list= [-1 -1 -1];
else
coordinate_list= sortrows(coordinate_list,[-5 10]);
end

File_Name = 'C:\mfrap\AFRAPcoordinates.csv';
dlmwrite(File_Name, coordinate_list,'newline','pc');



scrsz = get(0,'ScreenSize');
figure('Position',[1 scrsz(4)/2 scrsz(3)/2 scrsz(4)/2]), imshow(gray)

   for k = 1 : 10
      text(round(coordinate_list(k,1))+10,round(coordinate_list(k,2))+1,strcat (num2str(k),', ..   ',num2str(coordinate_list(k,6)),', ..   ',  num2str(coordinate_list(k,7)),', ..   ', num2str(coordinate_list(k,8)),', ..   ',num2str(coordinate_list(k,10)),', ..   ',num2str( coordinate_list(k,5))),'FontSize',11,'Color', 'g');
%        text(round(coordinate_list(k,1)),round(coordinate_list(k,2))+1,num2str(k),'FontSize',7,'Color', 'r');
   end

      for k = 11 : 20
%       text(round(coordinate_list(k,1)),round(coordinate_list(k,2))+1,num2str(k),'FontSize',7,'Color', 'y');
        text(round(coordinate_list(k,1))+10,round(coordinate_list(k,2))+1,strcat (num2str(k),', ..   ',num2str(coordinate_list(k,6)),',  ..  ', num2str(coordinate_list(k,7)),',  ..  ', num2str(coordinate_list(k,8)),',..    ',num2str(coordinate_list(k,10)),',..    ',num2str( coordinate_list(k,5))),'FontSize',11,'Color', 'y');
end
% BW3 = mtimes(edge(BW2),256);
% i(:,:,1)=i(:,:,1)+uint8(BW3);
% imshow(i)


%12(33) 41(37) 51(36) 19(31) 22(28) 25(27) 1(25) 6(36) 53(38)

%     black=zeros(size(BW2));
%     black(cells(index).PixelIdxList) = 255;
%     single_cell = (uint8(black)/255).*gray;
% z=imcrop(i,[cells(index).BoundingBox(1) cells(index).BoundingBox(2) cells(index).BoundingBox(3) cells(index).BoundingBox(4)]);
% std2(double(z))
% index=[12 41 51 19 22 25 1 6 53];

